' gestion d'un afficheur LCD 1 ligne de 16 caractres
'
'LCD  	1  2   3   4   5   6   7   8   9   10   11   12   13   14
'PORTB            PB6     PB7                   PB0  PB1  PB2  PB3
'                     
'******************************* lcd *****************************************

byte lcdbuf(16)

function lcdnib(c)
	PORTB = (c AND 0x4F) OR 0x30
	PORTB = PORTB OR 0x80		' EN = 1 500 ns
	PORTB = PORTB AND 0x7F
end function


function lcdnibw(c)
	lcdnib(c)
	lcdtempo(-1)
end function

function lcdputc(c)
	lcdnib(c/16)
	lcdnibw(c AND 0xF)
end function

function lcdinit()
	byte c
	PORTB = 0x30
	lcdtempo(5)		' 15 ms
	lcdnib(3)		' lcd = 3
	lcdtempo(1)		' 4.1 ms
	lcdnib(3)		' lcd = 3
	lcdtempo(1)		' .1 ms
	lcdnibw(3)		' lcd = 3 40us
	lcdnibw(2)		' lcd = 2 40us
	lcdputc(0x28)
	lcdputc(0x08)		' display off
	lcdputc(0x01)		' clear display
	lcdtempo(1)
	lcdputc(0x06)
	lcdputc(0x0E)		' display on , cursor
	for c=0 to 15
		lcdbuf(c) = ` `
	next c
	putchar(` `)
end function

function putchar(c)
	byte d
	for d=0 to 14
		lcdbuf(d) = lcdbuf(d+1)
	next d
	lcdbuf(15) = c
	lcdputc(0x80)
	for d=0 to 15
		if d = 8 then lcdputc(0x80+0x28)
		lcdnib ((lcdbuf(d)/16) OR 0x40)
		lcdnibw (lcdbuf(d)     OR 0x40)
	next d
end function

function lcdtempo(cnt)
	int bcl
	for cnt=cnt to 0 step -1
		for bcl=0 to 100
		next
	next
end function	